Skip to main content
`Ctrl`+`K`

# pandas.DataFrame.to_period

DataFrame.to_period(freq=None, axis=0, copy=None)

  Convert DataFrame from DatetimeIndex to PeriodIndex.

  Convert DataFrame from DatetimeIndex to PeriodIndex with desired frequency (inferred from index if not passed).

  Parameters:
    freq str, default

      Frequency of the PeriodIndex.

    axis{0 or ‘index’, 1 or ‘columns’}, default 0

      The axis to convert (the index by default).

    copy bool, default True

      If False then underlying input data is not copied.

      Note

      The copy keyword will change behavior in pandas 3.0. Copy-on-Write will be enabled by default, which means that all methods with a copy keyword will use a lazy copy mechanism to defer the copy and ignore the copy keyword. The copy keyword will be removed in a future version of pandas.

      You can already get the future behavior and improvements through enabling copy on write `pd.options.mode.copy_on_write = True`

  Returns:
    DataFrame

      The DataFrame has a PeriodIndex.

  Examples

      >>> idx = pd.to_datetime(
      ...     [
      ...         "2001-03-31 00:00:00",
      ...         "2002-05-31 00:00:00",
      ...         "2003-08-31 00:00:00",
      ...     ]
      ... )

      >>> idx
      DatetimeIndex(['2001-03-31', '2002-05-31', '2003-08-31'],
      dtype='datetime64[ns]', freq=None)

      >>> idx.to_period("M")
      PeriodIndex(['2001-03', '2002-05', '2003-08'], dtype='period[M]')

  For the yearly frequency

      >>> idx.to_period("Y")
      PeriodIndex(['2001', '2002', '2003'], dtype='period[Y-DEC]')